Index: /equalization_gain/trunk/src/PlotScurvesAll-diffFit.cc
===================================================================
--- /equalization_gain/trunk/src/PlotScurvesAll-diffFit.cc	(revision 207)
+++ /equalization_gain/trunk/src/PlotScurvesAll-diffFit.cc	(revision 208)
@@ -283,8 +1138,8 @@
     ifstream in(input[ch].Data());
     if(!in.good()){
-      cerr << "File " << input[ch] << " open failed!" << endl;
-      return;
-    }
-
+        cerr << "File " << input[ch] << " open failed!" << endl;
+        return;
+    }
+    
     // build the input data file name for each channel fname_ped-chXX.dat
     input_ped[ch] += fname_ped;
@@ -294,9 +1149,9 @@
     ifstream in_ped(input_ped[ch].Data());
     if(!in_ped.good()){
-      cerr << "File " << input_ped[ch] << " open failed!" << endl;
-      return;
-    }    
-
-
+        cerr << "File " << input_ped[ch] << " open failed!" << endl;
+        return;
+    }
+    
+    
     
     //10DAC~10mV
@@ -304,23 +1159,23 @@
     // and count the number of events
     Double_t da, dat, dac_min, dac_max, step_dac;
-    count = 0;
+    Int_t count = 0;
     while (in >> da >> dat ){
-      if(count==0) dac_min  = da;
-      if(count==1) step_dac = da - dac_min;
-      dac_max=da;
-      count++;
-    }      
+        if(count==0) dac_min  = da;
+        if(count==1) step_dac = da - dac_min;
+        dac_max=da;
+        count++;
+    }
     in.close();
     in.clear();
-
-    /*    
-    if(ch==43 || ch==47){//for T1 ASIC_C
-      cerr << "CHECK " << ch << " " << fit_min_scurve << endl;
-      Int_t fit_min_scurve=140;
-    } else {
-      Int_t fit_min_scurve=kFitMinS;
-    }
-    */
-
+    
+    /*
+     if(ch==43 || ch==47){//for T1 ASIC_C
+     cerr << "CHECK " << ch << " " << fit_min_scurve << endl;
+     Int_t fit_min_scurve=140;
+     } else {
+     Int_t fit_min_scurve=kFitMinS;
+     }
+     */
+    
     // correct the scale for DAC range
     if(kXmin<dac_min)kXmin=dac_min;
@@ -329,7 +1184,7 @@
     const Int_t kNdataFit = count;
     if(ch==0){
-      cerr << "kNdata, dac_min, dac_max, step_dac: " 
-	   << kNdata << " " << dac_min << " " << dac_max << " " 
-	   << step_dac << endl;
+        cerr << "kNdata, dac_min, dac_max, step_dac: "
+        << kNdata << " " << dac_min << " " << dac_max << " "
+        << step_dac << endl;
     }
     
@@ -337,19 +1192,19 @@
     count = 0;
     while (in_ped >> da >> dat ){
-      if(count==0) dac_min_ped  = da;
-      if(count==1) step_dac_ped = da - dac_min_ped;
-      dac_max_ped=da;
-      count++;
-    }
-      
+        if(count==0) dac_min_ped  = da;
+        if(count==1) step_dac_ped = da - dac_min_ped;
+        dac_max_ped=da;
+        count++;
+    }
+    
     in_ped.close();
     in_ped.clear();
     
-
+    
     const Int_t kNdataPed = count;
     if(ch==0){
-      cerr << "kNdataPed, dac_min_ped, dac_max_ped, step_dac_ped: " 
-	   << kNdataPed << " " << dac_min_ped << " " << dac_max_ped 
-	   << " " << step_dac_ped << endl;
+        cerr << "kNdataPed, dac_min_ped, dac_max_ped, step_dac_ped: "
+        << kNdataPed << " " << dac_min_ped << " " << dac_max_ped
+        << " " << step_dac_ped << endl;
     }
     
@@ -357,50 +1212,50 @@
     // SDC: 27/09/2013 hist_scurve is a pointer on an array of THD, thus the syntax is correct (no new operator)
     
-
+    
     hist_scurve[ch]      = TH1D(name_hist[ch],name_hist[ch],kNdata-1,
-				dac_min,dac_max);
+                                dac_min,dac_max);
     hist_scurve_ped[ch]  = TH1D(name_hist_ped[ch],name_hist_ped[ch],
-				kNdataPed-1,dac_min_ped,dac_max_ped);
+                                kNdataPed-1,dac_min_ped,dac_max_ped);
     hist_diff[ch]        = TH1D(name_hist_diff[ch],name_hist_diff[ch],
-				kNdata-2,dac_min,dac_max);
+                                kNdata-2,dac_min,dac_max);
     hist_diff_fit[ch]    = TH1D(name_hist_diff_fit[ch],name_hist_diff_fit[ch],
-				kNdataFit,fit_min_scurve,fit_max_scurve);
-
-    
-
-
-
+                                kNdataFit,fit_min_scurve,fit_max_scurve);
+    
+    
+    
+    
+    
     // read the data for that channel for normal data
     in.open(input[ch].Data());
     Double_t       data[kNdata], dac[kNdata], dac_fit[kNdataFit], data_fit[kNdataFit];
     while (in >> da >> dat ){
-      hist_scurve[ch].Fill(da,dat); // fill the histograms of the s-curve
+        hist_scurve[ch].Fill(da,dat); // fill the histograms of the s-curve
     }
     in.close();
     in.clear();
-
+    
     // read the data for pedestal data
     in_ped.open(input_ped[ch].Data());
     while (in_ped >> da >> dat ){
-      hist_scurve_ped[ch].Fill(da,dat); // fill the histogram for pedestal data
+        hist_scurve_ped[ch].Fill(da,dat); // fill the histogram for pedestal data
     }
     in_ped.close();
     in_ped.clear();
-
+    
     //dac_ped[ch]  = hist_scurve_ped[ch].GetMaximumBin()+dac_min_ped; //absolute value
     dac_ped[ch]  = hist_scurve_ped[ch].GetBinCenter(hist_scurve_ped[ch].GetMaximumBin()); //absolute value
     dac_ped_sum += dac_ped[ch]; //absolute value
-    //cerr << "dac_ped[" << ch << "] dac_ped_sum " << dac_ped[ch] 
+    //cerr << "dac_ped[" << ch << "] dac_ped_sum " << dac_ped[ch]
     //<< " " << dac_ped_sum << endl;
     
-
+    
     hist_scurve[ch].Smooth(3); // Smooth the S curve
     Int_t binx=0;
     //hist_scurve[ch].GetBinWithContent(kHalfMax,binx,kXmin-dac_min+1,
     //                                  dac_max-dac_min+1,kHalfMax/2.);
-
+    
     // ??????
     hist_scurve[ch].GetBinWithContent(kHalfMax,binx,kXmin-dac_min+1,
-				      dac_max-dac_min+1,2000);
+                                      dac_max-dac_min+1,2000);
     dac_half[ch] = hist_scurve[ch].GetBinCenter(binx); //absolute value
     if(dac_half[ch]<kXmin)dac_half[ch]=-1;
@@ -410,54 +1265,54 @@
     Int_t i=0;
     for(i=0;i<kNdata;i++){
-      dac[i]  = hist_scurve[ch].GetBinCenter(i+1);
-      data[i] = hist_scurve[ch].GetBinContent(i+1);
-    }
-   
+        dac[i]  = hist_scurve[ch].GetBinCenter(i+1);
+        data[i] = hist_scurve[ch].GetBinContent(i+1);
+    }
+    
     /*** compute derive diff on S-Curve ***/
     Double_t diff[kNdata-1], dac_diff[kNdata-1];
     Int_t trigger_diff=0;
     for(i=0;i<kNdata-1;i++){
-      diff[i]     = (data[i]-data[i+1])/step_dac;
-      dac_diff[i] = dac[i]+step_dac/2;
-      hist_diff[ch].Fill(dac_diff[i],diff[i]); // fills differentiated histograms of smoothed s-curves which is the single photoelectron spectrum
-      if(dac_diff[i]>=fit_min){
-	diff_sum += diff[i]*dac_diff[i];
-	//cerr << "diff[" << i << "], dac_diff[" << i << "] "
-	//<< diff[i] << " " << dac_diff[i] << endl;
-	trigger_diff+=diff[i];
-      }
+        diff[i]     = (data[i]-data[i+1])/step_dac;
+        dac_diff[i] = dac[i]+step_dac/2;
+        hist_diff[ch].Fill(dac_diff[i],diff[i]); // fills differentiated histograms of smoothed s-curves which is the single photoelectron spectrum
+        if(dac_diff[i]>=fit_min){
+            diff_sum += diff[i]*dac_diff[i];
+            //cerr << "diff[" << i << "], dac_diff[" << i << "] "
+            //<< diff[i] << " " << dac_diff[i] << endl;
+            trigger_diff+=diff[i];
+        }
     }
     //mean_diff[ch] = diff_sum/trigger_diff;
     hist_diff[ch].GetXaxis()->SetRangeUser(fit_min,fit_max);
     mean_diff[ch] = hist_diff[ch].GetMean();
-    //cerr << "trigger_diff, mean_diff[" << ch << "] " 
+    //cerr << "trigger_diff, mean_diff[" << ch << "] "
     //<< trigger_diff << " " << mean_diff[ch] << endl;
     
-   
+    
     /******************* GRAPHICS *****************/
-
-
+    
+    
     // Now start the analysis which consist in finding the peak in the differentiated spectrum
-    c1->cd(ch+1);    
+    c1->cd(ch+1);
     /*** fit scurves  ***/
     cerr << "ch " << ch;
-
+    
     //    SDC 24/09/2013 :: Need to declare outside this variable in a compiled program
     TF1 *fit_pol ;
-
-
+    
+    
     // Fit a polynomial curve in a given range on the s-curve directly. This is a kind of DEBUG procedure.
-
+    
     //if(ch==43 || ch==47){ // SDC: 25/09/2013 Why a special channel : the fit pol4 is performed for another DAC range
- /*   if(ch==170){
-      fit_pol      = new TF1("fit_pol","pol4",150,fit_max_scurve);
-      hist_scurve[ch].Fit(fit_pol,"","",150,fit_max_scurve);
-    }else{ */
-      fit_pol      = new TF1("fit_pol","pol4",fit_min_scurve,fit_max_scurve);
-      hist_scurve[ch].Fit(fit_pol,"","",fit_min_scurve,fit_max_scurve);
-   // }
-
-    
-
+    /*   if(ch==170){
+     fit_pol      = new TF1("fit_pol","pol4",150,fit_max_scurve);
+     hist_scurve[ch].Fit(fit_pol,"","",150,fit_max_scurve);
+     }else{ */
+    fit_pol      = new TF1("fit_pol","pol4",fit_min_scurve,fit_max_scurve);
+    hist_scurve[ch].Fit(fit_pol,"","",fit_min_scurve,fit_max_scurve);
+    // }
+    
+    
+    
     Double_t fit_par_pol4[5]; // container for fit parameter results
     fit_pol->GetParameters(fit_par_pol4);
@@ -466,36 +1321,36 @@
     Double_t data_diff_fit;
     for(i=0;i<kNdataFit;i++){
-      //if(ch==43 || ch==47){
-      if(ch==170){
-	dac_fit[i]  = hist_scurve[ch].GetBinCenter(i)+150-dac_min;
-	data_fit[i] = func->Eval(hist_scurve[ch].GetBinCenter(i)+150-dac_min); // get the value of the fitted function 
-      }else{
-	dac_fit[i]  = hist_scurve[ch].GetBinCenter(i)+fit_min_scurve-dac_min;
-	data_fit[i] = func->Eval(hist_scurve[ch].GetBinCenter(i)+fit_min_scurve-dac_min); // get the value of the fitted function
-	//cerr << "dac_fit[" << i << "], data_fit[" << i << "] "
-	//<< dac_fit[i] << " " << data_fit[i] << endl;
-      }
-    }
-
+        //if(ch==43 || ch==47){
+        if(ch==170){
+            dac_fit[i]  = hist_scurve[ch].GetBinCenter(i)+150-dac_min;
+            data_fit[i] = func->Eval(hist_scurve[ch].GetBinCenter(i)+150-dac_min); // get the value of the fitted function
+        }else{
+            dac_fit[i]  = hist_scurve[ch].GetBinCenter(i)+fit_min_scurve-dac_min;
+            data_fit[i] = func->Eval(hist_scurve[ch].GetBinCenter(i)+fit_min_scurve-dac_min); // get the value of the fitted function
+            //cerr << "dac_fit[" << i << "], data_fit[" << i << "] "
+            //<< dac_fit[i] << " " << data_fit[i] << endl;
+        }
+    }
+    
     // derive the fitted function on the S-curve to obtain the SPE
     Double_t dac_diff_fit;
     for(i=0;i<kNdataFit-1;i++){
-      data_diff_fit = (data_fit[i]-data_fit[i+1])/step_dac;
-      hist_diff_fit[ch].Fill(dac_fit[i],data_diff_fit); // Fill differentiated fitted S-curve
-    }
-
+        data_diff_fit = (data_fit[i]-data_fit[i+1])/step_dac;
+        hist_diff_fit[ch].Fill(dac_fit[i],data_diff_fit); // Fill differentiated fitted S-curve
+    }
+    
     TLine *lhalf_max   = new TLine(dac[0],kHalfMax,dac[kNdata-1],kHalfMax);
     TLine *ldac_half   = new TLine(dac_half[ch],0,dac_half[ch],
-				   (Double_t)kDrawMax);
+                                   (Double_t)kDrawMax);
     hist_scurve[ch].SetMaximum(kDrawMax);
     hist_scurve[ch].GetXaxis()->SetRangeUser(kDrawDacMin,kDrawDacMax);
     hist_scurve[ch].Draw();
-    lhalf_max->Draw("same");  
+    lhalf_max->Draw("same");
     ldac_half->Draw("same");
     if(dac_half[ch]>0){
-      dac_half_sum += dac_half[ch]-dac_ped[ch]; //relative absolute value
-      trigger++;
-    }
-
+        dac_half_sum += dac_half[ch]-dac_ped[ch]; //relative absolute value
+        trigger++;
+    }
+    
     /*** Differential plot from scurve fitting function  ***/
     c5->cd(ch+1);
@@ -504,23 +1359,23 @@
     //if(dac_sfit_max<=fit_min_scurve+4*step_dac){
     if(dac_sfit_max<=fit_min_scurve+2*step_dac){
-      hist_diff_fit[ch].GetXaxis()->SetRangeUser(fit_min_scurve+kFitSadj,fit_max_scurve-2*step_dac);
-      dac_sfit[ch]  =  hist_diff_fit[ch].GetBinCenter(hist_diff_fit[ch].GetMaximumBin());
-      //if(dac_sfit[ch]<=fit_min_scurve+kFitSadj+4*step_dac)dac_sfit[ch]=-1;
-      if(dac_sfit[ch]<fit_min_scurve+kFitSadj+step_dac){
-	dac_sfit[ch]=-1;
-	//dac_sfit[ch]=dac_half[ch];
-	flag_fit[ch] = -1;
-	cerr << "flag_fit[" << ch << "] " << flag_fit[ch]  << endl;
-      }
+        hist_diff_fit[ch].GetXaxis()->SetRangeUser(fit_min_scurve+kFitSadj,fit_max_scurve-2*step_dac);
+        dac_sfit[ch]  =  hist_diff_fit[ch].GetBinCenter(hist_diff_fit[ch].GetMaximumBin());
+        //if(dac_sfit[ch]<=fit_min_scurve+kFitSadj+4*step_dac)dac_sfit[ch]=-1;
+        if(dac_sfit[ch]<fit_min_scurve+kFitSadj+step_dac){
+            dac_sfit[ch]=-1;
+            //dac_sfit[ch]=dac_half[ch];
+            flag_fit[ch] = -1;
+            cerr << "flag_fit[" << ch << "] " << flag_fit[ch]  << endl;
+        }
     }else {
-      dac_sfit[ch]  =  hist_diff_fit[ch].GetBinCenter(hist_diff_fit[ch].GetMaximumBin());
-    }
-
+        dac_sfit[ch]  =  hist_diff_fit[ch].GetBinCenter(hist_diff_fit[ch].GetMaximumBin());
+    }
+    
     if(dac_sfit[ch]>fit_min_scurve+5){
-      dac_sfit_sum += dac_sfit[ch]-dac_ped[ch];
-      trigger_sfit++;
+        dac_sfit_sum += dac_sfit[ch]-dac_ped[ch];
+        trigger_sfit++;
     }else{
-      //dac_sfit[ch] = fit_min_scurve+10;
-      dac_sfit[ch] = -1;
+        //dac_sfit[ch] = fit_min_scurve+10;
+        dac_sfit[ch] = -1;
     }
     //cerr << "dac_sfit[" << ch << "] " << dac_sfit[ch] << endl;
@@ -543,6 +1398,6 @@
     mean_sum += mean_diff[ch]-dac_ped[ch];
     trigger_mean++;
-
-    // fit the derivated polynom fit 
+    
+    // fit the derivated polynom fit
     Double_t fit_par[3];
     //hist_diff[ch].Fit(fit_sdiff,"RQ0","",fit_min,fit_max);
@@ -556,20 +1411,20 @@
     dac_spe[ch] = fit_par[1];
     if(dac_spe[ch]>fit_min){
-      dac_spe_sum += dac_spe[ch]-dac_ped[ch];
-      //cerr << "dac_spe[" << ch << "] " << dac_spe[ch] << endl;
-      trigger_fit++;
+        dac_spe_sum += dac_spe[ch]-dac_ped[ch];
+        //cerr << "dac_spe[" << ch << "] " << dac_spe[ch] << endl;
+        trigger_fit++;
     }else{
-      dac_spe[ch] = fit_min+10;
+        dac_spe[ch] = fit_min+10;
     }
     //cerr << "dac_spe[" << ch << "] " << dac_spe[ch] << endl;
     TLine *ldac_spe    = new TLine(dac_spe[ch],0,dac_spe[ch],
-				 (Double_t)kDrawMaxDiff);
+                                   (Double_t)kDrawMaxDiff);
     ldac_spe->SetLineColor(kRed);
     TLine *lmean_diff  = new TLine(mean_diff[ch],0,mean_diff[ch],
-				   (Double_t)kDrawMaxDiff);
+                                   (Double_t)kDrawMaxDiff);
     lmean_diff->SetLineColor(kCyan);
     TLine *lfit_min    = new TLine(fit_min,0,fit_min,kDrawMaxDiff);
     lfit_min->SetLineColor(kGray);
-
+    
     ldac_spe->Draw();
     lmean_diff->Draw("same");
